<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die('Restricted access');
class ose_antihackerControllerConfiguration extends ose_antihackerController {
	public function __construct() {
		parent :: __construct();
	}
	public function getConfiguration()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null); 
		if (empty($type))
		{
			return; 
		}
		$model= $this->getModel('Configuration');
		$results = $model ->getConfiguration($type);
		oseCPU::returnJSON($results);  
	}
	public function saveConfigSEO()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null);
		if (empty($type)) {return;}
		$data = array();
		$data['pageTitle'] = $oseCPU -> getVar('pageTitle', null);
		$data['metaKeywords'] = $oseCPU -> getVar('metaKeywords', null);
		$data['metaDescription'] = $oseCPU -> getVar('metaDescription', null);
		$data['metaGenerator'] = $oseCPU -> getVar('metaGenerator', null);
		$data['adminEmail'] = $oseCPU -> getVar('adminEmail', null);
		$data['customBanpage'] = $oseCPU -> getHTML('customBanpage', null);	
		$data['scanGoogleBots'] = $oseCPU -> getInt('scanGoogleBots', 0);	
		$data['scanMsnBots'] = $oseCPU -> getInt('scanMsnBots', 0);	
		$data['scanYahooBots'] = $oseCPU -> getInt('scanYahooBots', 0);	
		$model= $this->getModel('Configuration');
		$result = $model ->saveConfiguration($type, $data);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The configuration was saved successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
	public function saveConfigScan()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null);
		if (empty($type)) {return;}
		$data = array();
		$data['secretword'] = $oseCPU -> getVar('secretword', null);
		$data['devMode'] = $oseCPU -> getInt('devMode', 0);
		$data['blockIP'] = $oseCPU -> getInt('blockIP', 0);
		$data['threshold'] = $oseCPU -> getInt('threshold', 20);
		$data['slient_max_att'] = $oseCPU -> getInt('slient_max_att', 10);
		$data['allowExts'] = $oseCPU -> getVar('allowExts', null);
		$data['scanFileVirus'] = $oseCPU -> getInt('scanFileVirus', 0);
		
		$model= $this->getModel('Configuration');
		$result = $model ->saveConfiguration($type, $data);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The configuration was saved successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
	public function saveConfAddon()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null);
		if (empty($type)) {return;}
		$data = array();
		$data['decduration'] = $oseCPU -> getInt('decduration', 0);
		$data['maxvisits'] = $oseCPU -> getInt('maxvisits', 0);
		$data['sfs_confidence'] = $oseCPU -> getInt('sfs_confidence', 20);
		$data['sfspam'] = $oseCPU -> getInt('sfspam', 10);
		$data['antiflooding'] = $oseCPU -> getInt('antiflooding', 0);
		$data['banpagetype'] = $oseCPU -> getInt('banpagetype', 0);
		
		$model= $this->getModel('Configuration');
		$result = $model ->saveConfiguration($type, $data);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The configuration was saved successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
	public function saveConfAdv()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null);
		if (empty($type)) {return;}
		$data = array();
		$data['convertFromSQLKeywords'] = $oseCPU -> getInt('convertFromSQLKeywords', 0);
		$data['runCentrifuge'] = $oseCPU -> getInt('runCentrifuge', 0);
		$data['scancookies'] = $oseCPU -> getInt('scancookies', 20);
		$data['scankey'] = $oseCPU -> getInt('scankey', 10);
		$data['scankeyLength'] = $oseCPU -> getInt('scankeyLength', 10);
		
		$model= $this->getModel('Configuration');
		$result = $model ->saveConfiguration($type, $data);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The configuration was saved successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
	public function saveConfL2Var()
	{
		$oseCPU = new oseCPU(); 
		$type = $oseCPU -> getVar('type', null);
		if (empty($type)) {return;}
		$data = array();
		foreach ($_POST as $key => $value)
		{
			if (strstr($key, 'convert'))
			{
				$data[$key] = (int)$value; 
			}	
		}
		$model= $this->getModel('Configuration');
		$result = $model ->saveConfiguration($type, $data);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The configuration was saved successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
	public function getActivationConfig()
	{
		$model= $this->getModel('Configuration');
		$results['success'] = true; 
		$results['data'] = $model ->getActivationConfig();
		oseCPU::returnJSON($results);  
	}
	public function createHTPass()
	{
		$oseCPU = new oseCPU(); 
		$authUser = $oseCPU -> getVar('authUser', null);
		$authPass = $oseCPU -> getVar('authPass', null);
		$backPath = $oseCPU -> getVar('backPath', null);
		if (empty($authUser) || empty($authPass) || empty($backPath)) 
		{
			oseCPU::ajaxResponse('ERROR', JText::_("The username / password cannot be empty."), false);
		}
		$model= $this->getModel('Configuration');
		$result = $model ->createHTPass($authUser, $authPass, $backPath);
		if ($result==true)
		{
			$msg = JText::_("The password was created successfully.").' <br/>Username: '.$authUser.'<br/>Password:'.$authPass;
			oseCPU::ajaxResponse('SUCCESS', $msg, true);
		} 
		else
		{
			oseCPU::ajaxResponse('ERROR', JText::_("The configuration was saved unsuccessfully."), false);
		}
	}
}	