<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die('Restricted access');
class ose_antihackerControllerLayer2attacks extends ose_antihackerController {
	public function __construct() {
		parent :: __construct();
	}
	public function getRulesets()
	{
		$model= $this->getModel('Layer2attacks');
		$results = $model ->getRulesets();
		oseCPU::returnJSON($results);  
	}
	public function changeRuleStatus()
	{
		$oseCPU = new oseCPU(); 
		$id= $oseCPU->getInt('id');
		$status= $oseCPU->getInt('status');
		if (empty($id) || ($status!=0 && $status!=1))
		{
			return; 
		}
		$model= $this->getModel('Layer2attacks');
		$result = $model -> changeRuleStatus(array($id), $status);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Signature rule has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Signature rule was changed unsuccessfully."), false);
		}
	}
	public function addruleset()
	{
		$oseCPU = new oseCPU(); 
		$filter= $oseCPU->getVar('filter',null);
		$status= $oseCPU->getInt('statusfield',null);
		$impact= $oseCPU->getInt('impactfield',null);
		$description= $oseCPU->getVar('descriptionfield',null);
		$attacktype_select = $oseCPU->getVar('attacktype_select',null);
		if (empty($filter) || ($status!==1 && $status!==0))
		{
			return; 
		}
		if (empty($impact))
		{
			oseCPU::ajaxResponse('ERROR', JText::_("Impact has to be an integer or greater than 0."), false);
		}
		$model= $this->getModel('Layer2attacks');
		$result = $model -> addruleset($filter, $status, $impact, $description, $attacktype_select);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The rule has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The rule was changed unsuccessfully."), false);
		}
	}
	public function deleteruleset()
	{
		$oseCPU = new oseCPU(); 
		$ids= $oseCPU->getVar('ids',null);
		$ids = oseJSON::decode($ids);
		if (empty($ids))
		{
			return; 
		}
		$model= $this->getModel('Layer2attacks');
		$result = $model -> deleteruleset($ids);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Signature rule has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Signature rule was changed unsuccessfully."), false);
		}
	}
	public function restoreruleset()
	{
		$model= $this->getModel('Layer2attacks');
		$result = $model -> restoreruleset();
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Signature rule has been restored successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Signature rule was restored unsuccessfully."), false);
		}
	}
	public function getAttackTypes()
	{
		$model= $this->getModel('Layer2attacks');
		$results = $model ->getAttackTypes();
		oseCPU::returnJSON($results); 
	}
}	