<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die('Restricted access');
class ose_antihackerControllerManageIPs extends ose_antihackerController {
	public function __construct() {
		parent :: __construct();
	}
	public function getACLIPMap()
	{
		$model= $this->getModel('ManageIps');
		$results = $model -> getACLIPMap(); 
		oseCPU::returnJSON($results);   
	}
	public function updateHost()
	{
		$oseCPU = new oseCPU(); 
		$aclids= $oseCPU -> getVar('ids', null);
		$aclids = oseJSON::decode($aclids); 
		$model= $this->getModel('ManageIps');
		$result = $model -> updateHost($aclids);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Host for this IP / IP Range was updated successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Host for this IP / IP Range was updated unsuccessfully."), false);
		}
	}
	public function addips() {
		$ipmanager = new oseFirewallIpManager();
		$oseCPU = new oseCPU(); 
		$ip_start = $oseCPU -> getVar('ip_start', null); 
		$ip_type =  $oseCPU -> getVar('ip_type', null);
		$ip_status = $oseCPU -> getInt('ip_status', 1);
		$title =  $oseCPU -> getVar('title', 'Backend Added IP');
		if ($ip_type=='ip')
		{
			$ip_end = $oseCPU -> getVar('ip_start', null);
		} 
		else
		{
			$ip_end = $oseCPU -> getVar('ip_end', null);
		}
		$ipmanager->setIPRange($ip_start, $ip_end);
		$this->checkIPValidity($ipmanager); 
		$ipmanager->checkIPRangeStatus(); 
		$acl_id = $ipmanager->getACLID();
		if (!empty($acl_id))
		{
			oseCPU::ajaxResponse('ERROR', JText::_("The Access Control Rules for this IP / IP Range already exists."), false);
		}
		else
		{
			$model= $this->getModel('ManageIps');
			$result = $model -> addACLRule($title, $ip_start, $ip_end, $ip_type, $ip_status);
			if ($result==true)
			{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Access Control Rules for this IP / IP Range was added successfully."), true);
			} 
			else
			{
				oseCPU::ajaxResponse('ERROR', JText::_("The Access Control Rules for this IP / IP Range was added unsuccessfully."), false);
			}
		}
	}
	public function removeips()
	{
		$oseCPU = new oseCPU(); 
		$aclids= $oseCPU -> getVar('ids', null);
		$aclids = oseJSON::decode($aclids); 
		$model= $this->getModel('ManageIps');
		$result = $model -> removeACLRule($aclids);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Access Control Rules for this IP / IP Range was removed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Access Control Rules for this IP / IP Range was removed unsuccessfully."), false);
		}
	}
	public function blacklistIP()
	{
		$this->changeACLStatus(1);
	}
	public function whitelistIP()
	{
		$this->changeACLStatus(3);
	}
	public function monitorIP()
	{
		$this->changeACLStatus(2);
	}
	public function changeIPStatus()
	{
		$oseCPU = new oseCPU(); 
		$aclid= $oseCPU->getInt('id');
		$status= $oseCPU->getInt('status');
		if (empty($aclid) || empty($status))
		{
			return; 
		}
		$model= $this->getModel('ManageIps');
		$result = $model -> changeACLStatus(array($aclid), $status);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Access Control Rules for this IP / IP Range has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Access Control Rules for this IP / IP Range has been changed unsuccessfully."), false);
		}
	}
	public function viewAttack()
	{
		$model = $this->getModel('ManageIps');
		$oseCPU = new oseCPU(); 
		$aclid= $oseCPU->getInt('id');
		$return = array();
		$return['id'] = 1; 
		$return['results'] = $model->getAttackDetail($aclid);
		oseCPU::returnJSON($return); 
	}
	private function changeACLStatus($status)
	{
		$oseCPU = new oseCPU(); 
		$aclids= $oseCPU->getVar('ids', null);
		$aclids = oseJSON::decode($aclids); 
		if (empty($aclids))
		{
			return; 
		}
		$model= $this->getModel('ManageIps');
		$result = $model -> changeACLStatus($aclids, $status);
		if ($result==true)
		{
				oseCPU::ajaxResponse('SUCCESS', JText::_("The Access Control Rules for this IP / IP Range has been changed successfully."), true);
		} 
		else
		{
				oseCPU::ajaxResponse('ERROR', JText::_("The Access Control Rules for this IP / IP Range has been changed unsuccessfully."), false);
		}
	}
	private function checkIPValidity($ipmanager)
	{
		$result =$ipmanager -> checkIPValidity(true);
		if ($result[0]==false)
		{
			oseCPU::ajaxResponse('ERROR', $result[1], false);
		}
		$result =$ipmanager -> checkIPValidity(false);
		if ($result[0]==false)
		{
			oseCPU::ajaxResponse('ERROR', $result[1], false);
		}
	}
	public function loadv5IPs()
	{
		$ipmanager = new oseFirewallIpManager();
		$oseCPU = new oseCPU(); 

		$db = OSEDBO::instance(); 
		$query = "SELECT acl.*, ip.host, (SELECT ip FROM `#__oseipm_iptable` WHERE id = MAX(ip.id)) AS ip_end, (SELECT ip FROM `#__oseipm_iptable` WHERE id = MIN(ip.id)) AS ip_start FROM `#__oseipm_iptable` AS ip, `#__oseipm_acl` AS acl GROUP BY ip.acl_id;";
		$db->setQuery($query);
		$results = $db->loadObjectList(); 
		$i= 0; 
		$return = true; 
		if (empty($results))
		{
			oseCPU::ajaxResponse('SUCCESS', JText::_("There are no IPs found in version 5 IP tables."), true);
		}
		else
		{
			foreach ($results as $result)
			{ 
				$results[$i]->score = $this->getScore ($result->id); 
				$ipmanager->setIPRange($result->ip_start, $result->ip_end);
				$ipmanager->checkIPRangeStatus(); 
				$acl_id = $ipmanager->getACLID();
				if (!empty($acl_id))
				{
					continue; 
				}
				else
				{
					$model= $this->getModel('ManageIps');
					$return = $model -> addACLRule($result->name, $result->ip_start, $result->ip_end, $result->iptype, $result->status);
				}
		}
		}
		if ($return==true)
		{
			oseCPU::ajaxResponse('SUCCESS', JText::_("The IPs in version 5 was restored successfully."), true);
		} 
		else
		{
			oseCPU::ajaxResponse('ERROR', JText::_("The IPs in version 5 was restored unsuccessfully."), false);
		}
	}
	private function getScore ($aclid)
	{
		$db = OSEDBO::instance(); 
		$query = "SELECT `score` FROM `#__oseath_alerts` WHERE `aclid` = ". (int)$aclid;
		$db->setQuery($query); 
		$score = $db->loadResult(); 
		return (int)$score;   
	}
}	