<?php
/**
 * @version     6.0 +
 * @package       Open Source Excellence Security Suite
 * @subpackage    Open Source Excellence CPU
 * @author        Open Source Excellence {@link http://www.opensource-excellence.com}
 * @author        Created on 30-Sep-2010
 * @author        Updated on 30-Mar-2013 
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 * @copyright Copyright (C) 2008 - 2010- ... Open Source Excellence
 *
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
defined('_OSEEXEC') or die("Direct Access Not Allowed");
class ose_antihackerModelAdminEmail extends ose_antihackerModel
{
	protected $lists= array(), $pagination= null;
	function __construct()
	{
		parent :: __construct();
	}
	public function getAdminEmailmap()
	{
		$oseCPU = new oseCPU();
		$oseCPU->callLibClass('emails', 'oseEmail');
		$oseEmail = new oseEmail('antihack');
		$return = array();
		$return['id']=1; 
		$return['results'] = $oseEmail->getAdminEmailList();
		if (empty($return['results']))
		{
			$return['results']['id'] = 0;
			$return['results']['user'] = 'N/A';
			$return['results']['subject'] = 'N/A';
		}		
		$return['total'] = COUNT($return['results']);
		return $return;  
	}
	public function getAdminUsers()
	{
		$oseCPU = new oseCPU();
		$oseCPU->callLibClass('users', 'oseUsers');
		$oseUsers = new oseUsers($oseCPU->getCMS());
		$return = array();
		$return['id']=1; 
		$return['results'] = $oseUsers->getAdminUsers();
		$return['total'] = COUNT($return['results']);
		return $return;  
	}
	public function getEmailList()
	{
		$oseCPU = new oseCPU();
		$oseCPU->callLibClass('emails', 'oseEmail');
		$oseEmail = new oseEmail('antihack');
		$return = array();
		$return['id']=1; 
		$return['results'] = $oseEmail->getEmailList();
		$return['total'] = $oseEmail->getEmailListTotal();
		return $return;  
	}
	public function addadminemailmap($userid, $emailid)
	{
		$oseCPU = new oseCPU();
		$oseCPU->callLibClass('emails', 'oseEmail');
		$oseEmail = new oseEmail('antihack');
		return $oseEmail->addadminemailmap($userid, $emailid); 
	}
	public function deleteadminemailmap($ids)
	{
		$oseCPU = new oseCPU();
		$oseCPU->callLibClass('emails', 'oseEmail');
		$oseEmail = new oseEmail('antihack');
		foreach ($ids as $id)
		{
			$result = $oseEmail->deleteadminemailmap($id->id, $id->email_id);
			if ($result == false)
			{
				return false;
			}
		}
		return true; 
	}
}