INSERT INTO `#__osefirewall_filters` (`id`, `filter`, `action`, `attacktype`, `impact`, `description`) VALUES
(1, '(?:"[^"]*[^-]?>)|(?:[^\\w\\s]\\s*\\/>)|(?:>")', 1, '["2","3"]', 4, 'finds html breaking injections including whitespace attacks'),
(2, '(?:"+.*[<=]\\s*"[^"]+")|(?:"\\s*\\w+\\s*=)|(?:>\\w=\\/)|(?:#.+\\)["\\s]*>)|(?:"\\s*(?:src|style|on\\w+)\\s*=\\s*")|(?:[^"]?"[,;\\s]+\\w*[\\[\\(])', 1, '["2","3"]', 4, 'finds attribute breaking injections including whitespace attacks'),
(3, '(?:^>[\\w\\s]*<\\/?\\w{2,}>)', 1, '["2","3"]', 2, 'finds unquoted attribute breaking injections'),
(4, '(?:[+\\/]\\s*name[\\W\\d]*[)+])|(?:;\\W*url\\s*=)|(?:[^\\w\\s\\/?:>]\\s*(?:location|referrer|name)\\s*[^\\/\\w\\s-])', 1, '["2","3"]', 5, 'Detects url-, name-, JSON, and referrer-contained payload attacks'),
(5, '(?:\\W\\s*hash\\s*[^\\w\\s-])|(?:\\w=\\W*[^,]*,[^\\s(]\\s*\\()|(?:\\?"[^\\s"]":)|(?:(?<!\\/)__[a-z]+__)|(?:(?:^|[\\s)\\]\\}])(?:s|g)etter\\s*=)', 1, '["2","3"]', 5, 'Detects hash-contained xss payload attacks, setter usage and property overloading'),
(6, '(?:with\\s*\\(\\s*.+\\s*\\)\\s*\\w+\\s*\\()|(?:(?:do|while|for)\\s*\\([^)]*\\)\\s*\\{)|(?:\\/[\\w\\s]*\\[\\W*\\w)', 1, '["2","3"]', 5, 'Detects self contained xss via with(), common loops and regex to string conversion'),
(7, '(?:[=(].+\\?.+:)|(?:with\\([^)]*\\)\\))|(?:\\.\\s*source\\W)', 1, '["2","3"]', 5, 'Detects JavaScript with(), ternary operators and XML predicate attacks'),
(8, '(?:\\/\\w*\\s*\\)\\s*\\()|(?:\\([\\w\\s]+\\([\\w\\s]+\\)[\\w\\s]+\\))|(?:(?<!(?:mozilla\\/\\d\\.\\d\\s))\\([^)[]+\\[[^\\]]+\\][^)]*\\))|(?:[^\\s!][{([][^({[]+[{([][^}\\])]+[}\\])][\\s+",\\d]*[}\\])])|(?:"\\)?\\]\\W*\\[)|(?:=\\s*[^\\s:;]+\\s*[{([][^}\\])]+[}\\])];)', 1, '["2","3"]', 5, 'Detects self-executing JavaScript functions'),
(9, '(?:\\\\u00[a-f0-9]{2})|(?:\\\\x0*[a-f0-9]{2})|(?:\\\\\\d{2,3})', 1, '["2","3"]', 2, 'Detects the IE octal, hex and unicode entities'),
(10, '(?:(?:\\/|\\\\)?\\.+(\\/|\\\\)(?:\\.+)?)|(?:\\w\\.exe\\??\\s)|(?:;\\s*\\w+\\s*\\/[\\w*-]+\\/)|(?:\\d\\.\\dx\\|)|(?:%(?:c0\\.|af\\.|5c\\.))|(?:\\/(?:%2e){2})', 1, '["8","7","6"]', 5, 'Detects basic directory traversal'),
(11, '(?:%c0%ae\\/)|(?:(?:\\/|\\\\)(home|conf|usr|etc|proc|opt|s?bin|local|dev|tmp|kern|[br]oot|sys|system|windows|winnt|program|%[a-z_-]{3,}%)(?:\\/|\\\\))|(?:(?:\\/|\\\\)inetpub|localstart\\.asp|boot\\.ini)', 1, '["8","7","6"]', 5, 'Detects specific directory and path traversal'),
(12, '(?:etc\\/\\W*passwd)', 1, '["8","7","6"]', 5, 'Detects etc/passwd inclusion attempts'),
(13, '(?:%u(?:ff|00|e\\d)\\w\\w)|(?:(?:%(?:e\\w|c[^3\\W]|))(?:%\\w\\w)(?:%\\w\\w)?)', 1, '["2","3"]', 3, 'Detects halfwidth/fullwidth encoded unicode HTML breaking attempts'),
(14, '(?:#@~\\^\\w+)|(?:\\wscript:|@import[^\\w]|;base64|base64,)|(?:\\w\\s*\\([\\w\\s]+,[\\w\\s]+,[\\w\\s]+,[\\w\\s]+,[\\w\\s]+,[\\w\\s]+\\))', 1, '["2","3","7","5"]', 5, 'Detects possible includes, VBSCript/JScript encodeed and packed functions'),
(15, '([^*:\\s\\w,.\\/?+-]\\s*)?(?<![a-z]\\s)(?<![a-z\\/_@\\-\\|])(\\s*return\\s*)?(?:create(?:element|attribute|textnode)|[a-z]+events?|setattribute|getelement\\w+|appendchild|createrange|createcontextualfragment|removenode|parentnode|decodeuricomponent|\\wettimeout|(?:ms)?setimmediate|option|useragent)(?(1)[^\\w%"]|(?:\\s*[^@\\s\\w%",.+\\-]))', 1, '["2","3","7","5"]', 6, 'Detects JavaScript DOM/miscellaneous properties and methods'),
(16, '([^*\\s\\w,.\\/?+-]\\s*)?(?<![a-mo-z]\\s)(?<![a-z\\/_@])(\\s*return\\s*)?(?:alert|inputbox|showmod(?:al|eless)dialog|showhelp|infinity|isnan|isnull|iterator|msgbox|executeglobal|expression|prompt|confirm|dialog|urn|(?:un)?eval|exec|execscript|tostring|status|execute|window|unescape|navigate|jquery|getscript|extend|prototype)(?(1)[^\\w%"]|(?:\\s*[^@\\s\\w%",.:\\/+\\-]))', 1, '["2","3","7","5"]', 5, 'Detects possible includes and typical script methods'),
(17, '([^*:\\s\\w,.\\/?+-]\\s*)?(?<![a-z]\\s)(?<![a-z\\/_@])(\\s*return\\s*)?(?:hash|name|href|navigateandfind|close|constructor|port|protocol|assign|replace|back|forward|document|ownerdocument|window|top|this|self|parent|frames|_?content|cookie|innerhtml|innertext|csstext+?|outerhtml|print|moveby|resizeto|createstylesheet|stylesheets)(?(1)[^\\w%"]|(?:\\s*[^@\\/\\s\\w%.+\\-]))', 1, '["2","3","7","5"]', 4, 'Detects JavaScript object properties and methods'),
(18, '([^*:\\s\\w,.\\/?+-]\\s*)?(?<![a-z]\\s)(?<![a-z\\/_@\\-\\|])(\\s*return\\s*)?(?:join|pop|push|reverse|reduce|concat|map|shift|sp?lice|sort|unshift)(?(1)[^\\w%"]|(?:\\s*[^@\\s\\w%,.+\\-]))', 1, '["2","3","7","5"]', 4, 'Detects JavaScript array properties and methods'),
(19, '([^*:\\s\\w,.\\/?+-]\\s*)?(?<![a-z]\\s)(?<![a-z\\/_@\\-\\|])(\\s*return\\s*)?(?:set|atob|btoa|charat|charcodeat|charset|concat|crypto|frames|fromcharcode|indexof|lastindexof|match|navigator|toolbar|menubar|replace|regexp|slice|split|substr|substring|escape|\\w+codeuri\\w*)(?(1)[^\\w%"]|(?:\\s*[^@\\s\\w%,.+\\-]))', 1, '["2","3","7","5"]', 4, 'Detects JavaScript string properties and methods'),
(20, '(?:\\)\\s*\\[)|([^*":\\s\\w,.\\/?+-]\\s*)?(?<![a-z]\\s)(?<![a-z_@\\|])(\\s*return\\s*)?(?:globalstorage|sessionstorage|postmessage|callee|constructor|content|domain|prototype|try|catch|top|call|apply|function|object|array|string|math|if|elseif|case|switch|regex|boolean|location|(?:ms)?setimmediate|settimeout|setinterval|void|setexpression|namespace|while)(?(1)[^\\w%"]|(?:\\s*[^@\\s\\w%".+\\-\\/]))', 1, '["2","3","7","5"]', 4, 'Detects JavaScript language constructs'),
(21, '(?:,\\s*(?:alert|showmodaldialog|eval)\\s*,)|(?::\\s*eval\\s*[^\\s])|([^:\\s\\w,.\\/?+-]\\s*)?(?<![a-z\\/_@])(\\s*return\\s*)?(?:(?:document\\s*\\.)?(?:.+\\/)?(?:alert|eval|msgbox|showmod(?:al|eless)dialog|showhelp|prompt|confirm|dialog|open))\\s*(?:[^.a-z\\s\\-]|(?:\\s*[^\\s\\w,.@\\/+-]))|(?:java[\\s\\/]*\\.[\\s\\/]*lang)|(?:\\w\\s*=\\s*new\\s+\\w+)|(?:&\\s*\\w+\\s*\\)[^,])|(?:\\+[\\W\\d]*new\\s+\\w+[\\W\\d]*\\+)|(?:document\\.\\w)', 1, '["2","3","7","5"]', 3, 'Detects very basic XSS probings'),
(22, '(?:=\\s*(?:top|this|window|content|self|frames|_content))|(?:\\/\\s*[gimx]*\\s*[)}])|(?:[^\\s]\\s*=\\s*script)|(?:\\.\\s*constructor)|(?:default\\s+xml\\s+namespace\\s*=)|(?:\\/\\s*\\+[^+]+\\s*\\+\\s*\\/)', 1, '["2","3","7","5"]', 5, 'Detects advanced XSS probings via Script(), RexExp, constructors and XML namespaces'),
(23, '(?:\\.\\s*\\w+\\W*=)|(?:\\W\\s*(?:location|document)\\s*\\W[^({[;]+[({[;])|(?:\\(\\w+\\?[:\\w]+\\))|(?:\\w{2}\\s*=\\s*\\d+[^&\\w]\\w+)|(?:\\]\\s*\\(\\s*\\w+)', 1, '["2","3"]', 5, 'Detects JavaScript location/document property access and window access obfuscation'),
(24, '(?:[".]script\\s*\\()|(?:\\$\\$?\\s*\\(\\s*[\\w"])|(?:\\/[\\w\\s]+\\/\\.)|(?:=\\s*\\/\\w+\\/\\s*\\.)|(?:(?:this|window|top|parent|frames|self|content)\\[\\s*[(,"]*\\s*[\\w\\$])|(?:,\\s*new\\s+\\w+\\s*[,;)])', 1, '["2","3"]', 5, 'Detects basic obfuscated JavaScript script injections'),
(25, '(?:=\\s*[$\\w]\\s*[\\(\\[])|(?:\\(\\s*(?:this|top|window|self|parent|_?content)\\s*\\))|(?:src\\s*=s*(?:\\w+:|\\/\\/))|(?:\\w\\[("\\w+"|\\w+\\|\\|))|(?:[\\d\\W]\\|\\|[\\d\\W]|\\W=\\w+,)|(?:\\/\\s*\\+\\s*[a-z"])|(?:=\\s*\\$[^([]*\\()|(?:=\\s*\\(\\s*")', 1, '["2","3"]', 5, 'Detects obfuscated JavaScript script injections'),
(26, '(?:[^:\\s\\w]+\\s*[^\\w\\/](href|protocol|host|hostname|pathname|hash|port|cookie)[^\\w])', 1, '["2","3"]', 4, 'Detects JavaScript cookie stealing and redirection attempts'),
(27, '(?:(?:vbs|vbscript|data):.*[,+])|(?:\\w+\\s*=\\W*(?!https?)\\w+:)|(jar:\\w+:)|(=\\s*"?\\s*vbs(?:ript)?:)|(language\\s*=\\s?"?\\s*vbs(?:ript)?)|on\\w+\\s*=\\*\\w+\\-"?', 1, '["2","5"]', 5, 'Detects data: URL injections, VBS injections and common URI schemes'),
(28, '(?:firefoxurl:\\w+\\|)|(?:(?:file|res|telnet|nntp|news|mailto|chrome)\\s*:\\s*[%&#xu\\/]+)|(wyciwyg|firefoxurl\\s*:\\s*\\/\\s*\\/)', 1, '["2","5","6","3"]', 5, 'Detects IE firefoxurl injections, cache poisoning attempts and local file inclusion/execution'),
(29, '(?:binding\\s?=|moz-binding|behavior\\s?=)|(?:[\\s\\/]style\\s*=\\s*[-\\\\])', 1, '["2","3","5"]', 4, 'Detects bindings and behavior injections'),
(30, '(?:=\\s*\\w+\\s*\\+\\s*")|(?:\\+=\\s*\\(\\s")|(?:!+\\s*[\\d.,]+\\w?\\d*\\s*\\?)|(?:=\\s*\\[s*\\])|(?:"\\s*\\+\\s*")|(?:[^\\s]\\[\\s*\\d+\\s*\\]\\s*[;+])|(?:"\\s*[&|]+\\s*")|(?:\\/\\s*\\?\\s*")|(?:\\/\\s*\\)\\s*\\[)|(?:\\d\\?.+:\\d)|(?:]\\s*\\[\\W*\\w)|(?:[^\\s]\\s*=\\s*\\/)', 1, '["2","3","7","5"]', 4, 'Detects common XSS concatenation patterns 1/2'),
(31, '(?:=\\s*\\d*\\.\\d*\\?\\d*\\.\\d*)|(?:[|&]{2,}\\s*")|(?:!\\d+\\.\\d*\\?")|(?:\\/:[\\w.]+,)|(?:=[\\d\\W\\s]*\\[[^]]+\\])|(?:\\?\\w+:\\w+)', 1, '["2","3","7","5"]', 4, 'Detects common XSS concatenation patterns 2/2'),
(32, '(?:[^\\w\\s=]on(?!g\\&gt;)\\w+[^=_+-]*=[^$]+(?:\\W|\\&gt;)?)', 1, '["2","3"]', 4, 'Detects possible event handlers'),
(33, '(?:\\<\\w*:?\\s(?:[^\\>]*)t(?!rong))|(?:\\<scri)|(<\\w+:\\w+)', 1, '["2"]', 4, 'Detects obfuscated script tags and XML wrapped HTML'),
(34, '(?:\\<\\/\\w+\\s\\w+)|(?:@(?:cc_on|set)[\\s@,"=])', 1, '["2","3"]', 4, 'Detects attributes in closing tags and conditional compilation tokens'),
(35, '(?:--[^\\n]*$)|(?:\\<!-|-->)|(?:[^*]\\/\\*|\\*\\/[^*])|(?:(?:[\\W\\d]#|--|{)$)|(?:\\/{3,}.*$)|(?:<!\\[\\W)|(?:\\]!>)', 1, '["2","3","7"]', 3, 'Detects common comment types'),
(36, '(?:\\<base\\s+)|(?:<!(?:element|entity|\\[CDATA))', 1, '["2","3","7"]', 5, 'Detects base href injections and XML entity injections'),
(37, '(?:\\<[\\/]?(?:[i]?frame|applet|isindex|marquee|keygen|script|audio|video|input|button|textarea|style|base|body|meta|link|object|embed|param|plaintext|xm\\w+|image|im(?:g|port)))', 1, '["2","3","7","5","6"]', 4, 'Detects possibly malicious html elements including some attributes'),
(38, '(?:\\\\x[01fe][\\db-ce-f])|(?:%[01fe][\\db-ce-f])|(?:&#[01fe][\\db-ce-f])|(?:\\\\[01fe][\\db-ce-f])|(?:&#x[01fe][\\db-ce-f])', 1, '["7","5","2"]', 5, 'Detects nullbytes and other dangerous characters'),
(39, '(?:\\)\\s*when\\s*\\d+\\s*then)|(?:"\\s*(?:#|--|{))|(?:\\/\\*!\\s?\\d+)|(?:ch(?:a)?r\\s*\\(\\s*\\d)|(?:(?:(n?and|x?or|not)\\s+|\\|\\||\\&\\&)\\s*\\w+\\()', 1, '["4","7","6"]', 6, 'Detects MySQL comments, conditions and ch(a)r injections'),
(40, '(?:[\\s()]case\\s*\\()|(?:\\)\\s*like\\s*\\()|(?:having\\s*[^\\s]+\\s*[^\\w\\s])|(?:if\\s?\\([\\d\\w]\\s*[=<>~])', 1, '["4","7","6"]', 6, 'Detects conditional SQL injection attempts'),
(41, '(?:"\\s*or\\s*"?\\d)|(?:\\\\x(?:23|27|3d))|(?:^.?"$)|(?:(?:^["\\\\]*(?:[\\d"]+|[^"]+"))+\\s*(?:n?and|x?or|not|\\|\\||\\&\\&)\\s*[\\w"[+&!@(),.-])|(?:[^\\w\\s]\\w+\\s*[|-]\\s*"\\s*\\w)|(?:@\\w+\\s+(and|or)\\s*["\\d]+)|(?:@[\\w-]+\\s(and|or)\\s*[^\\w\\s])|(?:[^\\w\\s:]\\s*\\d\\W+[^\\w\\s]\\s*".)|(?:\\Winformation_schema|table_name\\W)', 1, '["4","7","6"]', 6, 'Detects classic SQL injection probings 1/2'),
(42, '(?:"\\s*\\*.+(?:or|id)\\W*"\\d)|(?:\\^")|(?:^[\\w\\s"-]+(?<=and\\s)(?<=or\\s)(?<=xor\\s)(?<=nand\\s)(?<=not\\s)(?<=\\|\\|)(?<=\\&\\&)\\w+\\()|(?:"[\\s\\d]*[^\\w\\s]+\\W*\\d\\W*.*["\\d])|(?:"\\s*[^\\w\\s?]+\\s*[^\\w\\s]+\\s*")|(?:"\\s*[^\\w\\s]+\\s*[\\W\\d].*(?:#|--))|(?:".*\\*\\s*\\d)|(?:"\\s*or\\s[^\\d]+[\\w-]+.*\\d)|(?:[()*<>%+-][\\w-]+[^\\w\\s]+"[^,])', 1, '["4","7","6"]', 6, 'Detects classic SQL injection probings 2/2'),
(43, '(?:\\d"\\s+"\\s+\\d)|(?:^admin\\s*"|(\\/\\*)+"+\\s?(?:--|#|\\/\\*|{)?)|(?:"\\s*or[\\w\\s-]+\\s*[+<>=(),-]\\s*[\\d"])|(?:"\\s*[^\\w\\s]?=\\s*")|(?:"\\W*[+=]+\\W*")|(?:"\\s*[!=|][\\d\\s!=+-]+.*["(].*$)|(?:"\\s*[!=|][\\d\\s!=]+.*\\d+$)|(?:"\\s*like\\W+[\\w"(])|(?:\\sis\\s*0\\W)|(?:where\\s[\\s\\w\\.,-]+\\s=)|(?:"[<>~]+")', 1, '["4","7","6"]', 7, 'Detects basic SQL authentication bypass attempts 1/3'),
(44, '(?:union\\s*(?:all|distinct|[(!@]*)?\\s*[([]*\\s*select)|(?:\\w\\s+like\\s+\\")|(?:like\\s*"\\%)|(?:"\\s*like\\W*["\\d])|(?:"\\s*(?:n?and|x?or|not |\\|\\||\\&\\&)\\s+[\\s\\w]+=\\s*\\w+\\s*having)|(?:"\\s*\\*\\s*\\w+\\W+")|(?:"\\s*[^?\\w\\s=.,;)(]+\\s*[(@"]*\\s*\\w+\\W+\\w)|(?:select\\s*[\\[\\]()\\s\\w\\.,"-]+from)|(?:find_in_set\\s*\\()', 1, '["4","7","6"]', 7, 'Detects basic SQL authentication bypass attempts 2/3'),
(45, '(?:in\\s*\\(+\\s*select)|(?:(?:n?and|x?or|not |\\|\\||\\&\\&)\\s+[\\s\\w+]+(?:regexp\\s*\\(|sounds\\s+like\\s*"|[=\\d]+x))|("\\s*\\d\\s*(?:--|#))|(?:"[%&<>^=]+\\d\\s*(=|or))|(?:"\\W+[\\w+-]+\\s*=\\s*\\d\\W+")|(?:"\\s*is\\s*\\d.+"?\\w)|(?:"\\|?[\\w-]{3,}[^\\w\\s.,]+")|(?:"\\s*is\\s*[\\d.]+\\s*\\W.*")', 1, '["4","7","6"]', 7, 'Detects basic SQL authentication bypass attempts 3/3'),
(46, '(?:[\\d\\W]\\s+as\\s*["\\w]+\\s*from)|(?:^[\\W\\d]+\\s*(?:union|select|create|rename|truncate|load|alter|delete|update|insert|desc))|(?:(?:select|create|rename|truncate|load|alter|delete|update|insert|desc)\\s+(?:(?:group_)concat|char|load_file)\\s?\\(?)|(?:end\\s*\\);)|("\\s+regexp\\W)|(?:[\\s(]load_file\\s*\\()', 1, '["4","7","6"]', 5, 'Detects concatenated basic SQL injection and SQLLFI attempts'),
(47, '(?:@.+=\\s*\\(\\s*select)|(?:\\d+\\s*or\\s*\\d+\\s*[\\-+])|(?:\\/\\w+;?\\s+(?:having|and|or|select)\\W)|(?:\\d\\s+group\\s+by.+\\()|(?:(?:;|#|--)\\s*(?:drop|alter))|(?:(?:;|#|--)\\s*(?:update|insert)\\s*\\w{2,})|(?:[^\\w]SET\\s*@\\w+)|(?:(?:n?and|x?or|not |\\|\\||\\&\\&)[\\s(]+\\w+[\\s)]*[!=+]+[\\s\\d]*["=()])', 1, '["4","7"]', 6, 'Detects chained SQL injection attempts 1/2'),
(48, '(?:"\\s+and\\s*=\\W)|(?:\\(\\s*select\\s*\\w+\\s*\\()|(?:\\*\\/from)|(?:\\+\\s*\\d+\\s*\\+\\s*@)|(?:\\w"\\s*(?:[-+=|@]+\\s*)+[\\d(])|(?:coalesce\\s*\\(|@@\\w+\\s*[^\\w\\s])|(?:\\W!+"\\w)|(?:";\\s*(?:if|while|begin))|(?:"[\\s\\d]+=\\s*\\d)|(?:order\\s+by\\s+if\\w*\\s*\\()|(?:[\\s(]+case\\d*\\W.+[tw]hen[\\s(])', 1, '["4","7"]', 6, 'Detects chained SQL injection attempts 2/2'),
(49, '(?:(select|;)\\s+(?:benchmark|if|sleep)\\s*?\\(\\s*\\(?\\s*\\w+)', 1, '["4","7"]', 4, 'Detects SQL benchmark and sleep injection attempts including conditional queries'),
(50, '(?:create\\s+function\\s+\\w+\\s+returns)|(?:;\\s*(?:select|create|rename|truncate|load|alter|delete|update|insert|desc)\\s*[\\[(]?\\w{2,})', 1, '["4","7"]', 6, 'Detects MySQL UDF injection and other data/structure manipulation attempts'),
(51, '(?:alter\\s*\\w+.*character\\s+set\\s+\\w+)|(";\\s*waitfor\\s+time\\s+")|(?:";.*:\\s*goto)', 1, '["4","7"]', 6, 'Detects MySQL charset switch and MSSQL DoS attempts'),
(52, '(?:procedure\\s+analyse\\s*\\()|(?:;\\s*(declare|open)\\s+[\\w-]+)|(?:create\\s+(procedure|function)\\s*\\w+\\s*\\(\\s*\\)\\s*-)|(?:declare[^\\w]+[@#]\\s*\\w+)|(exec\\s*\\(\\s*@)', 1, '["4","7"]', 7, 'Detects MySQL and PostgreSQL stored procedure/function injections'),
(53, '(?:select\\s*pg_sleep)|(?:waitfor\\s*delay\\s?"+\\s?\\d)|(?:;\\s*shutdown\\s*(?:;|--|#|\\/\\*|{))', 1, '["4","7"]', 5, 'Detects Postgres pg_sleep injection, waitfor delay attacks and database shutdown attempts'),
(54, '(?:\\sexec\\s+xp_cmdshell)|(?:"\\s*!\\s*["\\w])|(?:from\\W+information_schema\\W)|(?:(?:(?:current_)?user|database|schema|connection_id)\\s*\\([^\\)]*)|(?:";?\\s*(?:select|union|having)\\s*[^\\s])|(?:\\wiif\\s*\\()|(?:exec\\s+master\\.)|(?:union select @)|(?:union[\\w(\\s]*select)|(?:select.*\\w?user\\()|(?:into[\\s+]+(?:dump|out)file\\s*")', 1, '["4","7"]', 5, 'Detects MSSQL code execution and information gathering attempts'),
(55, '(?:merge.*using\\s*\\()|(execute\\s*immediate\\s*")|(?:\\W+\\d*\\s*having\\s*[^\\s\\-])|(?:match\\s*[\\w(),+-]+\\s*against\\s*\\()', 1, '["4","7"]', 5, 'Detects MATCH AGAINST, MERGE, EXECUTE IMMEDIATE and HAVING injections'),
(56, '(?:,.*[)\\da-f"]"(?:".*"|\\Z|[^"]+))|(?:\\Wselect.+\\W*from)|((?:select|create|rename|truncate|load|alter|delete|update|insert|desc)\\s*\\(\\s*space\\s*\\()', 1, '["4","7"]', 5, 'Detects MySQL comment-/space-obfuscated injections and backtick termination'),
(57, '(?:@[\\w-]+\\s*\\()|(?:]\\s*\\(\\s*["!]\\s*\\w)|(?:<[?%](?:php)?.*(?:[?%]>)?)|(?:;[\\s\\w|]*\\$\\w+\\s*=)|(?:\\$\\w+\\s*=(?:(?:\\s*\\$?\\w+\\s*[(;])|\\s*".*"))|(?:;\\s*\\{\\W*\\w+\\s*\\()', 1, '["7","5","6"]', 7, 'Detects code injection attempts 1/3'),
(58, '(?:(?:[;]+|(<[?%](?:php)?)).*(?:define|eval|file_get_contents|include|require|require_once|set|shell_exec|phpinfo|system|passthru|preg_\\w+|execute)\\s*["(@])', 1, '["7","5","6"]', 7, 'Detects code injection attempts 2/3'),
(59, '(?:(?:[;]+|(<[?%](?:php)?)).*[^\\w](?:echo|print|print_r|var_dump|[fp]open))|(?:;\\s*rm\\s+-\\w+\\s+)|(?:;.*{.*\\$\\w+\\s*=)|(?:\\$\\w+\\s*\\[\\]\\s*=\\s*)', 1, '["7","5","6"]', 7, 'Detects code injection attempts 3/3'),
(60, '(?:function[^(]*\\([^)]*\\))|(?:(?:delete|void|throw|instanceof|new|typeof)[^\\w.]+\\w+\\s*[([])|([)\\]]\\s*\\.\\s*\\w+\\s*=)|(?:\\(\\s*new\\s+\\w+\\s*\\)\\.)', 1, '["7","5","6"]', 5, 'Detects common function declarations and special JS operators'),
(61, '(?:[\\w.-]@[\\w.-]+%(?:[01][\\db-ce-f])+\\w+:)', 1, '["7","11"]', 5, 'Detects common mail header injections'),
(62, '(?:\\.pl\\?\\w+=\\w?\\|\\w+;)|(?:\\|\\(\\w+=\\*)|(?:\\*\\s*\\)+\\s*;)', 1, '["6","5"]', 5, 'Detects perl echo shellcode injection and LDAP vectors'),
(63, '(?:(^|\\W)const\\s+[\\w\\-]+\\s*=)|(?:(?:do|for|while)\\s*\\([^;]+;+\\))|(?:(?:^|\\W)on\\w+\\s*=[\\w\\W]*(?:on\\w+|alert|eval|print|confirm|prompt))|(?:groups=\\d+\\(\\w+\\))|(?:(.)\\1{128,})', 1, '["5","9"]', 5, 'Detects basic XSS DoS attempts'),
(64, '(?:\\({2,}\\+{2,}:{2,})|(?:\\({2,}\\+{2,}:+)|(?:\\({3,}\\++:{2,})|(?:\\$\\[!!!\\])', 1, '["2","3","7","5","6"]', 7, 'Detects unknown attack vectors based on PHPIDS Centrifuge detection'),
(65, '(?:[\\s\\/"]+[-\\w\\/\\\\\\*]+\\s*=.+(?:\\/\\s*>))', 1, '["2","3"]', 4, 'Finds attribute breaking injections including obfuscated attributes'),
(66, '(?:(?:msgbox|eval)\\s*\\+|(?:language\\s*=\\*vbscript))', 1, '["2","3"]', 4, 'Finds basic VBScript injection attempts'),
(67, '(?:\\[\\$(?:ne|eq|lte?|gte?|n?in|mod|all|size|exists|type|slice|or)\\])', 1, '["4"]', 4, 'Finds basic MongoDB SQL injection attempts'),
(68, '(?:[\\s\\d\\/"]+(?:on\\w+|style|poster|background)=[$"\\w])|(?:-type\\s*:\\s*multipart)', 1, '["2","3"]', 6, 'finds malicious attribute injection attempts and MHTML attacks'),
(69, '(?:(sleep\\((\\s*)(\\d*)(\\s*)\\)|benchmark\\((.*)\\,(.*)\\)))', 1, '["4","7"]', 4, 'Detects blind sqli tests using sleep() or benchmark().'),
(70, '(?i:(\\%SYSTEMROOT\\%))', 1, '["10","7"]', 4, 'An attacker is trying to locate a file to read or write.'),
(71, '(?:(((.*)\\%[c|d|i|e|f|g|o|s|u|x|p|n]){8}))', 1, '["12"]', 4, 'Looking for a format string attack'),
(72, '(?:(union(.*)select(.*)from))', 1, '["4","7"]', 3, 'Looking for basic sql injection. Common attack string for mysql, oracle and others.'),
(73, '(?:^(-0000023456|4294967295|4294967296|2147483648|2147483647|0000012345|-2147483648|-2147483649|0000023456|2.2250738585072007e-308|1e309)$)', 1, '["4","7"]', 3, 'Looking for intiger overflow attacks, these are taken from skipfish, except 2.2250738585072007e-308 is the "magic number" crash');